Structure MyValueType
    Public theInt As Integer
End Structure

Class MyRefType
    Public theInt As Integer
End Class

Class RefValTesterClass
    Public Sub PassStructByVal(ByVal x As MyValueType)
        x.theInt = 30000
    End Sub
    Public Sub PassStructByRef(ByRef x As MyValueType)
        x.theInt = 30000
    End Sub
    Public Sub PassClassByVal(ByVal x As MyRefType)
        x.theInt = 30000
    End Sub
    Public Sub PassClassByRef(ByRef x As MyRefType)
        x.theInt = 30000
    End Sub
    Public Sub PassClassByValAndReassign(ByVal x As MyRefType)
        Dim another As New MyRefType()
        another.theInt = 666
        x = another ' Ceci sera oubli aprs l'appel
        Console.WriteLine("Tentative de raffectation ByVal du type ref vers {0}", x.theInt)
    End Sub
    Public Sub PassClassByRefAndReassign(ByRef x As MyRefType)
        Dim another As New MyRefType()
        another.theInt = 666
        x = another ' Ceci sera oubli aprs l'appel.
        Console.WriteLine("Tentative de raffectation ByVal du type ref vers {0}", x.theInt)
    End Sub
    Public Sub PassClassByValAndChangeState(ByVal x As MyRefType)
        ' Ceci va fonctionner.
        x.theInt = 777
    End Sub
    Public Sub PassClassByRefAndChangeState(ByRef x As MyRefType)
        ' Ceci va fonctionner.
        x.theInt = 888
    End Sub
    Public Sub ArrayByRef(ByRef x As Integer())
        x(0) = 999
    End Sub
    Public Sub ArrayByVal(ByVal x As Integer())
        x(0) = 101010
    End Sub
    Public Sub PassStringByRef(ByRef x As String)
        x = "Modifi dans PassStringByRef"
    End Sub
    Public Sub PassStringByVal(ByVal x As String)
        x = "Modifi dans PassStringByVal"
    End Sub

End Class

Module Module1

    Sub Main()
        ' **********************************************************
        ' Passage d'une structure par rfrence et par valeur
        Dim myStruct As MyValueType
        myStruct.theInt = 100
        Console.WriteLine("MyValueType.theInt comme dclare: {0}", _
                          myStruct.theInt)

        ' On tente une modification en utilisant ByVal.
        Dim t As New RefValTesterClass()
        t.PassStructByVal(myStruct)
        Console.WriteLine("MyValueType.theInt aprs ByVal : {0}", _
                                  myStruct.theInt)
        ' Puis on utilise ByRef.
        t.PassStructByRef(myStruct)
        Console.WriteLine("MyValueType.theInt aprs ByRef : {0}", _
                                  myStruct.theInt)
        Console.WriteLine()

        ' **********************************************************
        ' Passer une rfrence par rfrence ou par valeur
        Dim myRefType As New MyRefType()
        myRefType.theInt = 100
        Console.WriteLine("MyRefType.theInt comme dclare: {0}", _
                          myRefType.theInt)

        ' On tente une modification en utilisant ByVal.
        t.PassClassByVal(myRefType)
        Console.WriteLine("MyRefType.theInt aprs ByVal : {0}", _
                                  myRefType.theInt)
        ' Puis on utilise ByRef.
        t.PassClassByRef(myRefType)
        Console.WriteLine("MyValueType.theInt aprs ByRef : {0}", _
                                  myRefType.theInt)
        Console.WriteLine()

        ' **********************************************************
        ' On tente de raffecter ref en utilisant ByVal.
        Console.WriteLine("theInt avant la tentative de raffectation : {0}", _
                                          myRefType.theInt)
        t.PassClassByValAndReassign(myRefType)
        Console.WriteLine("theInt aprs la tentative de raffectation : {0}", _
                                          myRefType.theInt)
        Console.WriteLine()

        ' **********************************************************
        ' On tente de raffecter ref en utilisant ByRef.
        Console.WriteLine("theInt avant la tentative de raffectation : {0}", _
                                          myRefType.theInt)
        t.PassClassByRefAndReassign(myRefType)
        Console.WriteLine("theInt aaprs la tentative de raffectation : {0}", _
                                          myRefType.theInt)
        Console.WriteLine()

        ' **********************************************************
        ' On passe l'objet ByRef / ByVal et on laisse la mthode changer l'tat
        t.PassClassByValAndChangeState(myRefType)
        Console.WriteLine("theInt aprs la tentative de raffectation {0}", _
                                                  myRefType.theInt)
        t.PassClassByRefAndChangeState(myRefType)
        Console.WriteLine("theInt aprs la tentative de raffectation : {0}", _
                                                  myRefType.theInt)
        Console.WriteLine()


        ' **********************************************************
        ' Passer un tableau ByRef and ByVal
        Dim ar() As Integer = {0, 1, 2}
        Console.WriteLine("Array est dclar comme {0, 1, 2}")
        t.ArrayByVal(ar)
        Dim j As Integer
        For j = 0 To UBound(ar)
            Console.WriteLine("L'lment {0} est {1}", j, ar(j))
        Next
        t.ArrayByRef(ar)
        For j = 0 To UBound(ar)
            Console.WriteLine("L'lment {0} est {1}", j, ar(j))
        Next
        Console.WriteLine()

        ' **********************************************************
        ' Passer une chane ByRef and ByVal
        Dim s As String = "La chane initiale"
        Console.WriteLine("Valeur initiale: {0}", s)
        t.PassStringByVal(s)
        Console.WriteLine("La chane aprs ByVal: {0}", s)
        t.PassStringByRef(s)
        Console.WriteLine("La chane aprs ByRef: {0}", s)

    End Sub

End Module
