' Visual Basic permet d'imbriquer des classes, interfaces et structures.
' Ici, la voiture contient la radio.
Public Class Car
    ' Donnes d'tat internes.
    Private currSpeed As Integer
    Private maxSpeed As Integer
    Private petName As String

    ' La voiture est-elle en tat de marche ou hors-service ?
    Private dead As Boolean

    ' Une classe prive imbrique Radio.
    Private Class Radio
        Public Sub TurnOn(ByVal state As Boolean)

            If (state) Then
                Console.WriteLine("Diffusion en cours...")
            Else
                Console.WriteLine("Autoradio au repos...")
            End If
        End Sub
    End Class

    ' Une voiture possde un auto-radio.
    Private theMusicBox As Radio

    Public Sub New()
        maxSpeed = 100
        dead = False
        ' La classe externe cr la classe interne
        ' au dmarrage
        ' NOTE : Dans le cas contraire, theMusicBox serait
        ' initialis avec une rfrence nulle.
        theMusicBox = New Radio()
    End Sub

    Public Sub New(ByVal name As String, ByVal max As Integer, ByVal curr As Integer)
        currSpeed = curr
        maxSpeed = max
        petName = name
        dead = False
        theMusicBox = New Radio()
    End Sub

    Public Sub CrankTunes(ByVal state As Boolean)
        ' Demande le dmarrage de la radio (ou l'arrt).
        ' Dlgue la requte  l'objet interne.
        theMusicBox.TurnOn(state)
    End Sub

    Public Sub SpeedUp(ByVal delta As Integer)
        ' Si la voiture est hors-service, on l'indique...
        If (dead) Then
            Console.WriteLine(petName & " est hors-service....")
        Else ' en tat de marche, acclrer.
            currSpeed += delta
            If (currSpeed >= maxSpeed) Then
                Console.WriteLine(petName & " a surchauf...")
                dead = True
            Else
                Console.WriteLine("Vitesse actuelle = " & currSpeed)
            End If
        End If
    End Sub
End Class