Public Class Car
    ' Ce dlgu encapsule un pointeur sur fonction
    ' vers une mthode prenant un objet Car en paramtre et
    ' retournant un type void.
    ' Ceci est reprsent comme Car$CarDelegate (imbrique).
    Public Delegate Sub CarDelegate(ByVal c As Car)

    ' Le type imbriqu dans la classe Car.
    Public Class Radio
        Public Sub TurnOn(ByVal state As Boolean)
            If (state) Then
                Console.WriteLine("Diffusion en cours...")
            Else
                Console.WriteLine("Autoradio au repos...")
            End If
        End Sub
    End Class

    ' Donnes d'tat inerne.
    Private currSpeed As Integer
    Private maxSpeed As Integer
    Private petName As String

    ' La voiture est-elle en tat de marche ou hors-service ?
    Private dead As Boolean

    ' NOUVEAU !  A-t-elle besoin d'un nettoyage ?
    Private isDirty As Boolean

    ' NOUVEAU !  Faut-il changer les pneus ?
    Private shouldRotate As Boolean

    ' Une voiture est quipe d'un auto-radio.
    Private theMusicBox As radio

    Public Property Dirty() As Boolean
        Get
            Return isDirty
        End Get
        Set(ByVal Value As Boolean)
            isDirty = Value
        End Set
    End Property

    Public Property Rotate() As Boolean
        Get
            Return shouldRotate
        End Get
        Set(ByVal Value As Boolean)
            shouldRotate = Value
        End Set
    End Property

    Public Sub New()
        maxSpeed = 100
        dead = False
        theMusicBox = New Radio()
    End Sub
    Public Sub New(ByVal name As String, ByVal max As Integer, ByVal curr As Integer, ByVal dirty As Boolean, ByVal rotate As Boolean)
        currSpeed = curr
        maxSpeed = max
        petName = name
        dead = False
        isDirty = Dirty
        shouldRotate = rotate
        theMusicBox = New Radio()
    End Sub

    Public Sub CrankTunes(ByVal state As Boolean)
        ' Demande le dmarrage de la radio (ou l'arrt).
        ' Dlgue la requte  l'objet interne.
        theMusicBox.TurnOn(state)
    End Sub

    Public Sub SpeedUp(ByVal delta As Integer)
        ' Si la voiture est hors-service, on l'indique...
        If (dead) Then
            Console.WriteLine("La voiture est dj hors-service...")
        Else ' en tat de marche, acclrer.
            '            mCurrSpeed += delta
            currSpeed += delta
            If (currSpeed >= maxSpeed) Then
                dead = True
            Else
                Console.WriteLine("Vitesse actuelle = (0)", currSpeed)
            End If
        End If
    End Sub
End Class

